<?php
class MainWPExtensionsView
{
    public static function initMenu()
    {        
        add_submenu_page('mainwp_tab', __('Extensions', 'mainwp'), ' <span id="mainwp-Extensions">' . __('Extensions', 'mainwp') . '</span>', 'read', 'Extensions', array(MainWPExtensions::getClassName(), 'render'));     
    }

    public static function renderHeader($shownPage, &$extensions)
    {        
        ?>
    <div class="wrap">
        <a href="https://mainwp.com" id="mainwplogo" title="MainWP" target="_blank"><img
                src="<?php echo plugins_url('images/logo.png', dirname(__FILE__)); ?>" height="50"
                alt="MainWP"/></a>
        <img src="<?php echo plugins_url('images/icons/mainwp-extensions.png', dirname(__FILE__)); ?>"
             style="float: left; margin-right: 8px; margin-top: 7px ;" alt="MainWP Extensions" height="32"/>
        <h2><?php _e('Extensions', 'mainwp'); ?></h2><div style="clear: both;"></div><br/><br/>
        <?php if ($shownPage === '') { ?>
        <div id="mainwp-extensions-categories-menu" class="postbox">
                <div class="mainwp-inside"><span id="mainwp-extensions-menu-title"><?php _e('Get MainWP Extensions','mainwp');?></span></div>
                <div style="border-bottom: 1px Solid #e5e5e5;"></div>
                <div class="mainwp-inside mainwp-align-center" style="clear: both;">
                <div id="mainwp-extensions-cat-menu">
                    <ul id="mainwp-extensions-menu-cat-list">
                        <li class="mainwp-extensions-menu-item mainwp-category-1"><a href="https://extensions.mainwp.com/product-category/mainwp-extensions/administrative/"><?php _e('Administrative','mainwp'); ?></a></li>
                        <li class="mainwp-extensions-menu-item mainwp-category-2"><a href="https://extensions.mainwp.com/product-category/mainwp-extensions/content/"><?php _e('Content','mainwp'); ?></a></li>
                        <li class="mainwp-extensions-menu-item mainwp-category-3"><a href="https://extensions.mainwp.com/product-category/mainwp-extensions/visitor-data/"><?php _e('Visitor Data','mainwp'); ?></a></li>
                        <li class="mainwp-extensions-menu-item mainwp-category-4"><a href="https://extensions.mainwp.com/product-category/mainwp-extensions/free/"><?php _e('Free Extensions','mainwp'); ?></a></li>
                        <li class="mainwp-extensions-menu-item mainwp-category-5"><a href="https://extensions.mainwp.com/shop/"><?php _e('All Extensions','mainwp'); ?></a></li>
                    </ul>
                </div>
                    <div style="clear: both;"></div>
                </div>
        </div>        
       
<?php     
    
    $loader_url = plugins_url('images/loader.gif', dirname(__FILE__));      
    if (mainwp_current_user_can("dashboard", "bulk_install_and_activate_extensions")) {     

        $username = $password = "";
        $checked_save = false;
        if (get_option("mainwp_extensions_api_save_login") == true) {            
            $enscrypt_u = get_option('mainwp_extensions_api_username');
            $enscrypt_p = get_option('mainwp_extensions_api_password');
            $username = !empty($enscrypt_u) ? MainWPApiManagerPasswordManagement::decrypt_string($enscrypt_u) : "";
            $password = !empty($enscrypt_p) ? MainWPApiManagerPasswordManagement::decrypt_string($enscrypt_p) : "";             
            $checked_save = true;
        } 
    
        if (!MainWPUtility::resetUserCookie('api_bulk_install')) {
        ?>
            <span id="mainwp_api_postbox_reset_showhide"></span>
        <?php 
        }
?>
        
    <div class="postbox mainwp_api_postbox" section="1" >
           <div class="handlediv"><br></div>
           <h3 class="mainwp_box_title"><span><?php _e("Bulk Install and Activate Extensions", "mainwp"); ?></span></h3>                          
           <div class="mainwp-inside" style="clear: both;">
            <div style="padding: 0 5px;">
                <strong><?php _e("Step 1", "mainwp"); ?></strong>
                <p><span class="description"><?php _e("Enter your MainWP Extensions (https://extensions.mainwp.com) Login to automatically install and activate purchased extensions."); ?></span></p>
                <span><?php _e("MainWP Extensions Login:", "mainwp"); ?></span><br /><br />
                <div class="api-grabbing-fields">              
                    <input type="text" class="input username" placeholder="<?php echo __("Username", "mainwp"); ?>" value="<?php echo $username; ?>"/>&nbsp;
                    <input type="password" class="input passwd" placeholder="<?php echo __("Password", "mainwp"); ?>" value="<?php echo $password; ?>"/>&nbsp;
                    <label><input type="checkbox" <?php echo $checked_save ? 'checked="checked"' : ""; ?> name="extensions_api_savemylogin_chk" id="extensions_api_savemylogin_chk"><?php _e("Save API login", "mainwp"); ?></label>
                </div>  
                <p>
                    <span class="extension_api_loading">
                        <input type="button" class="button-primary" id="mainwp-extensions-savelogin" value="<?php _e("Save Login", "mainwp"); ?>">
                        <img class="hidden" src="<?php echo $loader_url; ?>"/><span class="status hidden"></span>
                    </span>
                </p>  
                <p><hr></p>            
                <strong><?php _e("Step 2", "mainwp"); ?></strong>
                <p><span class="description"><?php _e("The Install Purchased Extensions button will automatically install all all your MainWP Extensions. You can also install them manually using the directions <a href=\"http://docs.mainwp.com/how-to-install-mainwp-extensions/\" >here</a>."); ?></span></p>
                <p>
                    <span class="extension_api_loading">
                        <input type="button" class="mainwp-upgrade-button button-primary" id="mainwp-extensions-bulkinstall" value="<?php _e("Install purchased extensions", "mainwp"); ?>">
                        <img class="hidden" src="<?php echo $loader_url; ?>"/><span class="status hidden"></span>
                    </span>
                </p>                            
                <p><hr></p>
                <strong><?php _e("Step 3", "mainwp"); ?></strong>
                <p><span class="description"><?php _e("The Grap API Keys will automatically add your API Keys and activate your Extensions. You can also manually enter your API for each Extension following the steps <a href=\"http://docs.mainwp.com/enter-extensions-api-keys/\" >here</a>."); ?></span></p>
                <p>
                    <span class="extension_api_loading">
                        <input type="button" class="mainwp-upgrade-button button-primary" id="mainwp-extensions-grabkeys" value="<?php _e("Grab Api Keys", "mainwp"); ?>">
                        <img class="hidden" src="<?php echo $loader_url; ?>"/><span class="status hidden"></span>
                    </span>
                </p>  
                <div style="clear: both;"></div>
            </div>
        </div>
    </div> 
       <?php } ?>         
<?php } ?>    
        
        <div class="mainwp-tabs" id="mainwp-tabs">            
            <a class="nav-tab pos-nav-tab <?php if ($shownPage === '') { echo "nav-tab-active"; } ?>" href="admin.php?page=Extensions"><?php _e('Manage Extensions', 'mainwp'); ?></a>            
            <?php
            if (isset($extensions) && is_array($extensions))
            {
                foreach ($extensions as $extension)
                {
                    if ($extension['plugin'] == $shownPage)
                    {
                        ?>
                        <a class="nav-tab pos-nav-tab echo nav-tab-active" href="admin.php?page=<?php echo $extension['page']; ?>"><?php echo $extension['name']; ?></a>
                        <?php
                    }
                }
            }
            ?>
        </div>
        <div id="mainwp_wrap-inside">
        <?php
    }

    public static function renderFooter($shownPage, &$extensions)
    {
        ?>
        </div>
    </div>
        <?php
    }

    public static function render(&$extensions)
    {    
        
    $loader_url = plugins_url('images/loader.gif', dirname(__FILE__));            
    if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
        
        <?php } ?>
    <div class="postbox">
    <div class="handlediv"><br></div>
    <h3 class="mainwp_box_title"><span><?php printf(_n('%d Installed MainWP Extension', '%d Installed MainWP Extensions', (count($extensions) == 1 ? 1 : 2), 'mainwp'), count($extensions)); ?></span></h3>


<div id="mainwp-extensions-wrap">    
    <?php if (count($extensions) == 0)  { ?>
            <div class="mainwp_info-box-yellow">
                <h3><?php _e('What are Extensions?', 'mainwp'); ?></h3>
                <?php _e('Extensions are specific features or tools created for the purpose of expanding the basic functionality of MainWP.', 'mainwp'); ?>
                <h3><?php _e('Why have Extensions?', 'mainwp'); ?></h3>
                <?php _e('The core of MainWP has been designed to provide the functions most needed by our users and minimize code bloat.  Extensions offer custom functions and features so that each user can tailor their MainWP to their specific needs.', 'mainwp'); ?>
                <p><a href="https://extensions.mainwp.com/"><?php _e('Download your first extension now.', 'mainwp'); ?></a></p>
            </div>
<?php  }  else {            
?>
<div style="background: #eee; padding: 1em .6em;">
<a class="mainwp_action left mainwp_action_down" href="#" id="mainwp-extensions-expand"><?php _e('Expand', 'mainwp'); ?></a><a class="mainwp_action right" href="#" id="mainwp-extensions-collapse"><?php _e('Collapse', 'mainwp'); ?></a>  
<?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
    <div style="float: right; margin-top: -3px;"><a href="#" class="button mainwp-extensions-disable-all"><?php _e('Disable All', 'mainwp'); ?></a> <a href="#" class="button-primary mainwp-extensions-enable-all"><?php _e('Enable All', 'mainwp'); ?></a> <a href="<?php echo admin_url( 'plugin-install.php?tab=upload' ); ?>" class="mainwp-upgrade-button button-primary button"><?php _e('Install New Extension', 'mainwp'); ?></a></div>
<?php } ?>
</div>
<div id="mainwp-extensions-list">
        <?php       
    if (isset($extensions) && is_array($extensions))
    {
        foreach ($extensions as $extension)
        {
            if (!mainwp_current_user_can("extension", dirname($extension['slug'])))
               continue;
            $active = MainWPExtensions::isExtensionEnabled($extension['plugin']);
            
            $queue_status = "";
            
            if (isset($extension['apiManager']) && $extension['apiManager']) { 
                $queue_status = 'status="queue"';
            }
?>
        <div class="mainwp-extensions-childHolder" extension_slug="<?php echo $extension['slug']; ?>" <?php echo $queue_status; ?> license-status="<?php echo $active ? "activated" : "deactivated"; ?>">
            <table style="width: 100%">
                <td class="mainwp-extensions-childIcon">
                    <?php
                    if (isset($extension['iconURI']) && ($extension['iconURI'] != ''))
                    {
                        ?><img title="<?php echo $extension['name']; ?>" src="<?php echo MainWPUtility::removeHttpPrefix($extension['iconURI']); ?>" class="mainwp-extensions-img large <?php echo ($active ? '' : 'mainwp-extension-icon-desaturated'); ?>" /><?php
                    }
                    else
                    {
                        ?><img title="MainWP Placeholder" src="<?php echo plugins_url('images/extensions/placeholder.png', dirname(__FILE__)); ?>" class="mainwp-extensions-img large <?php echo ($active ? '' : 'mainwp-extension-icon-desaturated'); ?>" /><?php
                    }
?>
                </td>
                <td valign="top">
                    <table style="width: 100%">
                        <tr>
                            <td class="mainwp-extensions-childName">
                                <?php 
                                    if (isset($extension['direct_page']) && !empty($extension['direct_page'])) { 
                                        ?>
                                        <a href="<?php echo admin_url('admin.php?page='.$extension['direct_page']); ?>" style="text-decoration: none;">
                                            <?php echo $extension['name']; ?>
                                        </a>
                                <?php } 
                                    else if (isset($extension['callback'])) { 
                                ?>
                                        <a href="<?php echo admin_url('admin.php?page='.$extension['page']); ?>" style="text-decoration: none;">    
                                            <?php echo $extension['name']; ?>
                                        </a>
                                <?php } 
                                    else {
                                            echo $extension['name'];
                                } ?>
                            </td>
                            <td class="mainwp-extensions-childVersion">V. <?php echo $extension['version']; ?></td>
                            <td class="mainwp-extensions-childActions">
                                <?php if ($active) { ?>
                                    <?php if (isset($extension['apiManager']) && $extension['apiManager'] && !empty($extension['api_key'])) { ?>
                                        <a href="javascript:void(0)" class="api-status activated" ><?php _e('Activated','mainwp'); ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                        <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>                                    
                                        <a href="#" class="mainwp-extensions-api-activation"><img src="<?php echo plugins_url('images/extensions/unlock.png', dirname(__FILE__)); ?>" title="Activated" /></a>
                                        <?php }  ?>
                                    <?php } else {  ?>
                                        <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
                                            <a href="#" class="button mainwp-extensions-disable"><?php _e('Disable','mainwp'); ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                            <img src="<?php echo plugins_url('images/extensions/unlock.png', dirname(__FILE__)); ?>" title="Activated" />
                                        <?php } //  ?>
                                    <?php }  ?>
                                    <?php if (isset($extension['direct_page']) && !empty($extension['direct_page'])) { ?>
                                        <a href="<?php echo admin_url('admin.php?page='.$extension['direct_page']); ?>"><img src="<?php echo plugins_url('images/extensions/settings.png', dirname(__FILE__)); ?>" title="Settings" /></a>
                                    <?php } else if (isset($extension['callback'])) { ?>
                                        <a href="<?php echo admin_url('admin.php?page='.$extension['page']); ?>"><img src="<?php echo plugins_url('images/extensions/settings.png', dirname(__FILE__)); ?>" title="Settings" /></a>
                                    <?php } else { ?>
                                        <img src="<?php echo plugins_url('images/extensions/settings-freeze.png', dirname(__FILE__)); ?>" title="Settings" />
                                    <?php } ?>
                                    <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
                                    <img src="<?php echo plugins_url('images/extensions/trash-freeze.png', dirname(__FILE__)); ?>" title="Delete" />
                                    <?php } //  ?>
                                <?php } else {
                                    $apilink = '';
                                    $locked = false;
                                    if (isset($extension['mainwp']) && ($extension['mainwp'] == true))
                                    {
                                        //MainWP plugin, check if it requires authentication
                                        if (isset($extension['api']))
                                        {
                                            $apilink = admin_url('admin.php?page=Settings');
                                            //plugin locked (api not valid)
                                            $locked = (MainWPAPISettings::testAPIs($extension['api']) != 'VALID');
                                        }
                                    }
                                    else
                                    {
                                        //Third party plugin, check if it requires authentication
                                        if (isset($extension['apilink']))
                                        {
                                            $apilink = $extension['apilink'];
                                            //plugin locked
                                            $locked = (isset($extension['locked']) && ($extension['locked'] == true));
                                        }
                                    }
                                    ?>
                                    <?php if (isset($extension['apiManager']) && $extension['apiManager'] && !empty($extension['api_key'])) { ?>
                                        <a href="javascript:void(0)" class="api-status deactivated" title="Not Activated"><?php _e('Deactivated','mainwp'); ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                        <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>                                                                               
                                            <a href="#" class="mainwp-extensions-api-activation"><img class="image-api-status" src="<?php echo plugins_url('images/extensions/lock.png', dirname(__FILE__)); ?>" title="Not Activated" /></a>                                    
                                        <?php } ?>
                                    <?php } else { ?>
                                        <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
                                        <button class="button-primary mainwp-extensions-enable" <?php echo ($locked ? 'disabled' : ''); ?>><?php _e('Enable','mainwp'); ?></button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                        <?php if ($apilink != '') { ?>
                                        <a href="<?php echo $apilink; ?>"><img src="<?php echo plugins_url('images/extensions/'.(!$locked ? 'un' : '') . 'lock.png', dirname(__FILE__)); ?>" title="Not Activated" /></a>
                                        <?php } else { ?>
                                        <img src="<?php echo plugins_url('images/extensions/unlock.png', dirname(__FILE__)); ?>" title="Activated" /></a>
                                        <?php }?>
                                        <?php } ?>                                        
                                    <?php } ?>
                                        
                                    <?php if (isset($extension['callback'])) { ?>
                                        <a href="<?php echo admin_url('admin.php?page='.$extension['page']); ?>"><img src="<?php echo plugins_url('images/extensions/settings.png', dirname(__FILE__)); ?>" title="Settings" /></a>
                                    <?php } else { ?>
                                        <img src="<?php echo plugins_url('images/extensions/settings-freeze.png', dirname(__FILE__)); ?>" title="Settings" />
                                    <?php } ?>
                                    <?php if (mainwp_current_user_can("dashboard", "manage_extensions")) { ?>
                                    <a href="#" class="mainwp-extensions-trash"><img src="<?php echo plugins_url('images/extensions/trash.png', dirname(__FILE__)); ?>" title="Delete" /></a>
                                    <?php } ?>
                                <?php } ?>
                            </td>
                        </tr>
                        <tr class="mainwp-extensions-extra mainwp-extension-description"><td colspan="3"><br/><br/><?php echo preg_replace('/\<cite\>.*\<\/cite\>/', '', $extension['description']); ?><br/><br/></td></tr>
                        <tr class="mainwp-extensions-links">
                            <td colspan="3">
                                <?php printf(__('By %s', 'mainwp'), $extension['author']); ?>
                                <?php echo (isset($extension['DocumentationURI']) && !empty($extension['DocumentationURI'])) ? ' | <a href="' . $extension['DocumentationURI'] . '" target="_blank" title="' . __("Documentation", "mainwp") . '">' . __("Documentation", "mainwp") . '</a>' : ""; ?>
                                <?php echo (isset($extension['SupportForumURI']) && !empty($extension['SupportForumURI'])) ? ' | <a href="' . $extension['SupportForumURI'] . '" target="_blank" title="' . __("Support Forum", "mainwp") . '">' . __("Support Forum", "mainwp") . '</a>' : ""; ?>
                                <?php if (isset($extension['apiManager']) && $extension['apiManager']) { ?>
                                    <?php echo ' | <a href="#" class="mainwp-extensions-api-activation" >' . __('Enter Activation API') . '</a>'; ?>
                                <?php } ?>
                            </td></tr>
                        <?php if (isset($extension['apiManager']) && $extension['apiManager']) { ?>
                        <tr class="mainwp-extensions-api-row">
                            <td colspan="3">
                                <div class="api-row-div">
                                    <span>
                                    <input type="text" class="input api_key" placeholder="<?php echo __("API License Key", "mainwp"); ?>" value="<?php echo $extension["api_key"]; ?>"/>
                                    <input type="text" class="input api_email" placeholder="<?php echo __("API License Email", "mainwp"); ?>" value="<?php echo $extension["activation_email"]; ?>"/>
                                    <input type="button" class="button-primary mainwp-extensions-activate" value="<?php _e("Activate", "mainwp"); ?>">                            
                                    <span class="mainwp_loading"><img src="<?php echo $loader_url; ?>"/></span>
                                    </span>
                                    <span style="float:right">
                                    <?php _e("Deactivate License Key", "mainwp"); ?>
                                    <input type="checkbox" class="mainwp-extensions-deactivate-chkbox" <?php echo $extension['deactivate_checkbox'] == 'on' ? "checked" : ""; ?>>
                                    <input type="button" class="button-primary mainwp-extensions-deactivate" value="<?php _e("Deactivate", "mainwp"); ?>">                                
                                    </span>
                                </div>
                                <span class="activate-api-status hidden"></span>
                            </td>
                        </tr>
                        <?php } ?>
                    </table>
                </td>
            </table>
        </div>

        <?php
        }
    }
        ?>

</div>
        <?php
        }
        ?>
</div></div><?php
        self::mainwpAvailableExtensions($extensions);
    }
    public static function mainwpAvailableExtensions($extensions) {
        
        $all_extensions = array(                
            array(
                    'free' => true,
                    'slug' => 'advanced-uptime-monitor-extension',
                    'title' => 'MainWP Advanced Uptime Monitor',
                    'desc' => 'MainWP Extension for real-time up time monitoring.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-advanced-uptime-monitor/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2013/06/Advanced-Uptime-Monitor-300x300.png'
                ),
            array(
                    'slug' => 'mainwp-article-uploader-extension',
                    'title' => 'MainWP Article Uploader Extension',
                    'desc' => 'MainWP Article Uploader Extension allows you to bulk upload articles to your dashboard and publish to child sites.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-article-uploader-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/08/mainwp-article-uploader-extension.png'
                ),
            array(
                    'slug' => 'boilerplate-extension',
                    'title' => 'MainWP Boilerplate Extension',
                    'desc' => 'MainWP Boilerplate extension allows you to create, edit and share repetitive pages across your network of child sites. The available placeholders allow these pages to be customized for each site without needing to be rewritten. The Boilerplate extension is the perfect solution for commonly repeated pages such as your "Privacy Policy", "About Us", "Terms of Use", "Support Policy", or any other page with standard text that needs to be distributed across your network.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-boilerplate-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/boilerplate-icon-300x300.png'
                ),
            array(
                    'slug' => 'mainwp-branding-extension',
                    'title' => 'MainWP Branding Extension',
                    'desc' => 'The MainWP Branding extension allows you to alter the details of the MianWP Child Plugin to reflect your companies brand or completely hide the plugin from the installed plugins list.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-child-plugin-branding-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/03/mainwp-child-pllugin-branding-extension.png'
                ),
            array(
                    'slug' => 'mainwp-broken-links-checker-extension',
                    'title' => 'MainWP Broken Links Checker Extension',
                    'desc' => 'MainWP Broken Links Checker Extension allows you to scan and fix broken links on your child sites. Requires the MainWP Dashboard Plugin.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-broken-links-checker-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/07/mainwp-broken-links-checker-extension.png'
                ),
             array(
                    'free' => true,
                    'slug' => 'mainwp-clean-and-lock-extension',
                    'title' => 'MainWP Clean and Lock Extension',
                    'desc' => 'MainWP Clean and Lock Extension enables you to remove unwanted WordPress pages from your dashboard site and to control access to your dashboard admin area.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-clean-lock-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/07/mainwp-clean-and-lock-extension.png'
                ),
            array(
                    'slug' => 'mainwp-heatmap-extension',
                    'title' => 'MainWP Click Heatmap Extension',
                    'desc' => 'MainWP Click Heatmap Extension is an extension for the MainWP plugin that enables you to track visitors clicks on your child sites.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-click-heatmaps-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-heatmaps-ext-icon.png'
                ),
            array(
                    'slug' => 'mainwp-client-reports-extension',
                    'title' => 'MainWP Client Reports Extension',
                    'desc' => 'MainWP Client Reports Extension allows you to generate activity reports for your clients sites. Requires MainWP Dashboard.',
                    'link' => 'https://extensions.mainwp.com/product/mainwp-client-reports-extension/',
                    'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/05/mainwp-client-reports-extension.png'
                ),
            array(
                'slug' => 'mainwp-clone-extension',
                'title' => 'MainWP Clone Extension',
                'desc' => 'MainWP Clone Extension is an extension for the MainWP plugin that enables you to clone your child sites with no technical knowledge required.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-clone-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-clone-ext-icon.png'
            ),
            array(
                'slug' => 'mainwp-code-snippets-extension',
                'title' => 'MainWP Code Snippets Extension',
                'desc' => 'The MainWP Code Snippets Extension is a powerful PHP platform that enables you to execute php code and scripts on your child sites and view the output on your Dashboard. Requires the MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-code-snippets-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/04/mainwp-code-snippets-extension.png'
            ),
            array(
                'slug' => 'mainwp-comments-extension',
                'title' => 'MainWP Comments Extension',
                'desc' => 'MainWP Comments Extension is an extension for the MainWP plugin that enables you to manage comments on your child sites.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-comments-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-comments-ext-icon.png'
            ),
            array(
                'slug' => 'mainwp-favorites-extension',
                'title' => 'MainWP Favorites Extension',
                'desc' => 'MainWP Favorites is an extension for the MainWP plugin that allows you to store your favorite plugins and themes, and install them directly to child sites from the dashboard repository.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-favorites-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-favorites-icon.png'
            ),
            array(
                'slug' => 'mainwp-file-uploader-extension',
                'title' => 'MainWP File Uploader Extension',
                'desc' => 'MainWP File Uploader Extension gives you an simple way to upload files to your child sites! Requires the MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-file-uploader-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/05/mainwp-file-uploader-extension.png'
            ),
            array(
                'slug' => 'mainwp-google-analytics-extension',
                'title' => 'MainWP Google Analytics Extension',
                'desc' => 'MainWP Google Analytics Extension is an extension for the MainWP plugin that enables you to monitor detailed statistics about your child sites traffic. It integrates seamlessly with your Google Analytics account.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-google-analytics-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-ga-ext-icon.png'
            ),
            array(
                'slug' => 'mainwp-links-manager-extension',
                'title' => 'MainWP Links Manager',
                'desc' => 'MainWP Links Manager is an Extension that allows you to create, manage and track links in your posts and pages for all your sites right from your MainWP Dashboard.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-links-manager/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2013/08/links-manager-1.png'
            ),
            array(
                'slug' => 'mainwp-maintenance-extension',
                'title' => 'MainWP Maintenance Extension',
                'desc' => 'MainWP Maintenance Extension is MainWP Dashboard extension that clears unwanted entries from child sites in your network. You can delete post revisions, delete auto draft pots, delete trash posts, delete spam, pending and trash comments, delete unused tags and categories and optimize database tables on selected child sites.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-maintenance-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/Maintenance-Icon-3-300x300.png'
            ),
            array(
                'slug' => 'mainwp-piwik-extension',
                'title' => 'MainWP Piwik Extension',
                'desc' => 'MainWP Piwik Extension is an extension for the MainWP plugin that enables you to monitor detailed statistics about your child sites traffic. It integrates seamlessly with your Piwik account.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-piwik-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/03/mainwp-piwik-extension.png'
            ),
            array(
                'slug' => 'mainwp-post-dripper-extension',
                'title' => 'MainWP Post Dripper Extension',
                'desc' => 'MainWP Post Dripper Extension allows you to deliver posts or pages to your network of sites over a pre-scheduled period of time. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-post-dripper-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/05/mainwp-post-dripper-extension.png'
            ),
            array(
                'slug' => 'mainwp-remote-backup-extension',
                'title' => 'MainWP Remote Backups Extension',
                'desc' => 'MainWP Remote Backup Extension is an extension for the MainWP plugin that enables you store your backups on different off site locations.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-remote-backups-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/01/mainwp-remote-backups-ext-icon.png'
            ),
            array(
                'free' => true,
                'slug' => 'mainwp-spinner',
                'title' => 'MainWP Spinner',
                'desc' => 'MainWP Extension Plugin allows words to spun {|} when when adding articles and posts to your blogs. Requires the installation of MainWP Main Plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-spinner/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2013/06/spinner-300x300.png'
            ),
            array(
                'free' => true,
                'slug' => 'mainwp-sucuri-extension',
                'title' => 'MainWP Sucuri Extension',
                'desc' => 'MainWP Sucuri Extension enables you to scan your child sites for various types of malware, spam injections, website errors, and much more. Requires the MainWP Dashboard.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-sucuri-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/03/mainwp-sucuri-extension.png'
            ),
            array(
                'slug' => 'mainwp-team-control',
                'title' => 'MainWP Team Control',
                'desc' => 'MainWP Team Control extension allows you to create a custom roles for your dashboard site users and limiting their access to MainWP features. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-team-control/',
                'img' => 'https://extensions.mainwp.com/wp-content/uploads/2014/10/mainwp-team-control-extension.png'
            ),
            array(
                'slug' => 'mainwp-url-extractor-extension',
                'title' => 'MainWP URL Extractor Extension',
                'desc' => 'MainWP URL Extractor allows you to search your child sites post and pages and export URLs in customized format. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-url-extractor-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/05/mainwp-url-extractor-extension.png'
            ),
            array(
                'free' => true,
                'slug' => 'mainwp-woocommerce-shortcuts-extension',
                'title' => 'MainWP WooCommerce Shortcuts Extension',
                'desc' => 'MainWP WooCommerce Shortcuts provides you a quick access WooCommerce pages in your network. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-woocommerce-shortcuts-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/06/mainwp-woocommerce-shortcuts-extension.png'
            ),
            array(
                'slug' => 'mainwp-woocommerce-status-extension',
                'title' => 'MainWP WooCommerce Status Extension',
                'desc' => 'MainWP WooCommerce Status provides you a quick overview of your WooCommerce stores in your network. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-woocommerce-status-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/06/mainwp-woocommerce-status-extension.png'
            ),
            array(
                'slug' => 'mainwp-wordfence-extension',
                'title' => 'MainWP WordFence Extension',
                'desc' => 'The WordFence Extension combines the power of your MainWP Dashboard with the popular WordPress Wordfence Plugin. It allows you to manage WordFence settings, Monitor Live Traffic and Scan your child sites directly from your dashboard. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/mainwp-wordfence-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/09/mainwp-wordfence-icon.png'
            ),
            array(
                'slug' => 'wordpress-seo-extension',
                'title' => 'MainWP WordPress SEO Extension',
                'desc' => 'MainWP WordPress SEO extension by MainWP enables you to manage all your WordPress SEO by Yoast plugins across your network. Create and quickly set settings templates from one central dashboard. Requires MainWP Dashboard plugin.',
                'link' => 'https://extensions.mainwp.com/product/wordpress-seo-extension/',
                'img' => 'http://extensions.mainwp.com/wp-content/uploads/2014/05/wordpress-seo-extension.png'
            ),
        );
              
        $installed_slugs = array();
        if (is_array($extensions)) {
            foreach($extensions as $ext) {
                $installed_slugs[] = dirname($ext['slug']);
            }
        }
        
        ?>
        <div class="postbox">
            <div class="handle"></div>
            <h3 class="mainwp_box_title"><?php _e('Available Extensions on <a href="http://extensions.mainwp.com">MainWP Extensions</a>'); ?></h3>
            <div>
                <div id="mainwp-available-extensions-list">
                    <?php
                        foreach($all_extensions as $ext ) {
                            if (in_array($ext['slug'], $installed_slugs))
                                    continue;
                            $is_free = (isset($ext['free']) && $ext['free']) ? true : false;
                                ?>
                                <div class="mainwp-availbale-extension-holder <?php echo ($is_free) ? 'mainwp-free' : 'mainwp-paid'; ?>" style="clear: both;">
                                    <div class="mainwp-av-ext-icon">
                                        <img src="<?php echo $ext['img']?>" />
                                    </div>
                                    <div class="mainwp-av-ext-buttons">
                                        <?php
                                        echo $is_free ? '<span class="mainwp-price"></span>' : '';
                                        ?>                                        
                                        <a href="<?php echo $ext['link']?>" class="button">Find Out More</a>
                                        <a href="<?php echo $ext['link']?>" class="button button-primary mainwp-upgrade-button">Order Now</a>
                                    </div>
                                    <div class="mainwp-av-ext-desciption">
                                        <h2><?php echo $ext['title']?></h2>
                                        <p><?php echo $ext['desc']?></p>
                                    </div>

                                </div>
                    <?php } ?>
<!--                    <div class="mainwp-availbale-extension-holder " style="clear: both;">
                        <div class="mainwp-av-ext-icon">
                            <img src="https://extensions.mainwp.com/wp-content/uploads/2014/07/mainwp-clean-and-lock-extension.png" />
                        </div>
                        <div class="mainwp-av-ext-buttons">
                            <a href="https://extensions.mainwp.com/product/mainwp-clean-lock-extension/" class="button">Find Out More</a>
                            <a href="https://extensions.mainwp.com/product/mainwp-clean-lock-extension/" class="button button-primary mainwp-upgrade-button">Order Now</a>
                        </div>
                        <div class="mainwp-av-ext-desciption">
                            <h2>MainWP Clean and Lock Extension</h2>
                            <p>MainWP Clean and Lock Extension enables you to remove unwanted WordPress pages from your dashboard site and to control access to your dashboard admin area.</p>
                        </div>
                        
                    </div>-->
                </div>
            </div>
        </div>
        <?php
        }
    }
